#
# canvtree.py
# $Id: canvtree.py,v 1.4 1996/09/12 13:35:43 kzeil Exp $
#
# Koert Zeilstra - Network Solutions
# 1996.09.05
#

import string
import Tkinter

# --------------------------------------------------
# TreeItem
# --------------------------------------------------
class TreeItem:
  def __init__ (self, label=None, label_tags=None,
	images=[], subtree=None):
    self._label = label
    self._label_tags = label_tags
    self._images = images
    self._subtree = subtree
    self._expandable = 0
    self._expand_callback = None

  def setImages (self, images):
    self._images = images
  def setSubtree(self, subtree):
    self._subtree = subtree

  def getLabel(self):
    return self._label
  def getLabelTags(self):
    return self._label_tags
  def getImages(self):
    return self._images
  def getSubtree(self):
    return self._subtree
  def getExpandable(self):
    return self._expandable
  def getExpandCallback(self):
    return self._expand_callback

  def makeExpandable(self, callback):
    self._expandable = 1
    self._expand_callback = callback

# --------------------------------------------------
# Tree
# --------------------------------------------------
class Tree:
  def __init__ (self):
    self._items = []
    self._colors = {"read": "yellow", "normal": "black",
		"select": "blue"}
    self._type_font = "-*-lucida-medium-r-*-*-*-120-*-*-*-*-*-*"
    self._line_height = 12
    self._x_indent = 15
    self._x_margin = 30
    self._y_margin = 5

  #def addField (self, tags, images, label):
  #  item = TreeItem(tags, image, label)
  #  self._items.append(item)

  #def addSubTree (self, tags, image, label, tree):
  #  item = TreeItem(tags, image, label, tree)
  #  self._items.append(item)

  def addItem (self, item):
    self._items.append(item)

  def getHeight (self):
    height = (len(self._items)+1) * (self._line_height + self._y_margin)
    for item in self._items:
      subtree = item.getSubtree()
      if subtree != None:
        height = height + subtree.getHeight()
    return height

  def display (self, canvas, x, y):
    for item in self._items:
      image_list = item.getImages()
      delta_x = -15
      for image_item, image_tags in image_list:
        item_id = canvas.create_image(x+delta_x, y, image=image_item,
		anchor="nw", tags=image_tags)
        delta_x = delta_x + image_item.width() + 2
      #if item_image:
      #  item_id = canvas.create_image(x-15, y, image=item_image,
	#	anchor="nw", tags=item.getImageTags())
      item_id = canvas.create_text(x+delta_x, y, text=item.getLabel(), anchor="nw",
		font=self._type_font, fill=self._colors["normal"],
		tags=item.getLabelTags())
      y = y + self._line_height + self._y_margin
      if item.getSubtree():
        previous_y = y
        x_dummy, y = item.getSubtree().display(canvas, x+15, y)
        canvas.create_line(x-10, previous_y, x-10, y-5, fill="white",
		width=2)
    return x, y
