#
# labelentry.py
#
# Copyright 1995 - Koert Zeilstra
#
# No warranty - use at your own risk
#

import Tkinter

NORMAL = 0
DISABLED = 1

class LabelEntry(Tkinter.Frame):
  def __init__ (self, parent, labeltext, labelwidth, entrywidth,
		variable=None):
    Tkinter.Frame.__init__(self, parent)
    self._state = DISABLED
    self.label = Tkinter.Label(self, {"text": labeltext,
		"anchor": "e", "width": labelwidth})
    self.label.pack ({"side": "left"})
    if variable == None:
      self.entry = Tkinter.Entry(self, {"width": entrywidth})
    else:
      self.entry = Tkinter.Entry(self, {"width": entrywidth, "textvariable": variable})
    self.entry.pack ({"side": "left"})

  def setEditable(self, flag):
    if flag:
      self.entry.config(bd=2, state="normal")
      self._state = NORMAL
    else:
      self.entry.config(bd=0, state="disabled")
      self._state = DISABLED

  def setEntry (self, text):
    if self._state == DISABLED:
      self.entry.config(state="normal")
    self.entry.delete(0, "end")
    self.entry.insert(0, text)
    if self._state == DISABLED:
      self.entry.config(state="disabled")

  def getEntry (self):
    return self.entry.get()

  #def pack (self, config):
  #  self.frame.pack(config)




