#
# recordinfo.py
# $Id: recordinfo.py,v 1.2 1996/09/16 16:28:57 kzeil Exp $
#
# Koert Zeilstra - Network Solutions
# 1996.09.09
#

import Tkinter

import labelentry

class RecordInfoDialog(Tkinter.Toplevel):
  def __init__(self, parent):
    Tkinter.Toplevel.__init__(self, parent)

    self.title('PyRwhois - Record Info')
    self.iconname('PyRwhois')

    self._close_command = None

    self._type = labelentry.LabelEntry(self, "Record Type", 10, 25)
    self._type.pack(side="top", fill="x")
    self._handle = labelentry.LabelEntry(self, "ID", 10, 25)
    self._handle.pack(side="top", fill="x")
    self._server_name = labelentry.LabelEntry(self, "Server", 10, 35)
    self._server_name.pack(side="top", fill="x")
    self._server_port = labelentry.LabelEntry(self, "Port", 10, 6)
    self._server_port.pack(side="top", fill="x")

    buttons = Tkinter.Frame(self)
    close_btn = Tkinter.Button(buttons, text="Close", width=8,
				command=self.close)
    close_btn.pack(side="left", padx=5, pady=3)
    buttons.pack(side="top")

    self.protocol("WM_DELETE_WINDOW", self.close)

  def close(self):
    if self._close_command:
      self._close_command()
    else:
      self.withdraw()

  def closeCommand(self, command):
    self._close_command = command

  def showRecord(self, record):
    self._type.setEntry(record.getSchemaName())
    self._handle.setEntry(record.getId())
    self._server_name.setEntry(record.getHost())
    self._server_port.setEntry(record.getPort())
